<?php
if ( ! function_exists( 'pet_house_setup' ) ) :
function pet_house_setup() {

// Root path/URI.
define( 'PET_HOUSE_PARENT_DIR', get_template_directory() );
define( 'PET_HOUSE_PARENT_URI', get_template_directory_uri() );

// Root path/URI.
define( 'PET_HOUSE_PARENT_INC_DIR', PET_HOUSE_PARENT_DIR . '/inc');
define( 'PET_HOUSE_PARENT_INC_URI', PET_HOUSE_PARENT_URI . '/inc');

	// Add default posts and comments RSS feed links to head.
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'wc-product-gallery-zoom' );
	add_theme_support( 'wc-product-gallery-slider' );

	/*
	 * Let WordPress manage the document title.
	 */
	add_theme_support( 'title-tag' );

	add_theme_support( 'responsive-embeds' );
	
	/*
	 * Enable support for Post Thumbnails on posts and pages.
	 */
	add_theme_support( 'post-thumbnails' );
	
	//Add selective refresh for sidebar widget
	add_theme_support( 'customize-selective-refresh-widgets' );
	
	/*
	 * Make theme available for translation.
	 */
	load_theme_textdomain( 'pet-house', get_stylesheet_directory() . '/languages' );
		
	// This theme uses wp_nav_menu() in one location.
	register_nav_menus( array(
		'primary'  => esc_html__( 'Primary Menu', 'pet-house' ),
	) );

	/*
	 * Switch default core markup for search form, comment form, and comments
	 * to output valid HTML5.
	 */
	add_theme_support( 'html5', array(
		'search-form',
		'comment-form',
		'comment-list',
		'gallery',
		'caption',
	) );
		
	add_theme_support('custom-logo');

	/*
	 * WooCommerce Plugin Support
	 */
	add_theme_support( 'woocommerce' );
	
	// Gutenberg wide images.
	add_theme_support( 'align-wide' );
	
	
	//Set up the WordPress core custom background feature.
	add_theme_support( 'custom-background', apply_filters( 'pet_house_custom_background_args', array(
		'default-color' => 'ffffff',
		'default-image' => '',
	) ) );

	/*
	 * This theme styles the visual editor to resemble the theme style,
	 * specifically font, colors, icons, and column width.
	 */
	add_editor_style( array( 'assets/css/editor-style.css', pet_house_google_font_url() ) );

    add_theme_support( 'custom-header', apply_filters( 'pet_house_custom_header_args', array(
		'default-image'          => get_template_directory_uri() . '/assets/images/custom-header.png',
		'default-text-color'     => 'ffffff',
		'width'                  => 2000, 
		'height'                 => 200,
		'flex-width'    		 => true,
		'flex-height'    		 => true,
        'uploads'            => true,
	)));


    /*
    * Enable support for Post Formats.
    *
    * See: https://codex.wordpress.org/Post_Formats
    */
    add_theme_support( 'post-formats', array('image','video','gallery','audio',) );


    //  --------------------------------------------- ENQUEUE ----------------------------------------------------- //

    /**
     * Implement the Custom Header feature.
     */
    require_once get_template_directory() . '/inc/custom-header.php';

    /**
     * Demo Import
     */
    require get_parent_theme_file_path( '/demo-import/demo-import-settings.php' );

    	if ( ! defined( 'PET_HOUSE_FREE_THEME_URL' ) ) {
		define( 'PET_HOUSE_FREE_THEME_URL', 'https://www.seothemesexpert.com/products/free-pet-wordpress-theme' );
	}
	if ( ! defined( 'PET_HOUSE_PRO_THEME_URL' ) ) {
		define( 'PET_HOUSE_PRO_THEME_URL', 'https://www.seothemesexpert.com/products/pet-website-template' );
	}
	if ( ! defined( 'PET_HOUSE_FREE_DOC_URL' ) ) {
		define( 'PET_HOUSE_FREE_DOC_URL', 'https://demo.seothemesexpert.com/documentation/animal-pet-house/' );
	}
	if ( ! defined( 'PET_HOUSE_DEMO_THEME_URL' ) ) {
		define( 'PET_HOUSE_DEMO_THEME_URL', 'https://demo.seothemesexpert.com/animal-pet-house/' );
	}
	if ( ! defined( 'PET_HOUSE_DOCS_THEME_URL' ) ) {
		define( 'PET_HOUSE_DOCS_THEME_URL', 'https://demo.seothemesexpert.com/documentation/animal-pet-house-pro/' );
	}
	if ( ! defined( 'PET_HOUSE_RATE_THEME_URL' ) ) {
		define( 'PET_HOUSE_RATE_THEME_URL', 'https://wordpress.org/support/theme/pet-house/reviews/#new-post' );
	}
	if ( ! defined( 'PET_HOUSE_SUPPORT_THEME_URL' ) ) {
		define( 'PET_HOUSE_SUPPORT_THEME_URL', 'https://wordpress.org/support/theme/pet-house/' );
	}
	if ( ! defined( 'PET_HOUSE_THEME_BUNDLE_URL' ) ) {
		define( 'PET_HOUSE_THEME_BUNDLE_URL', 'https://www.seothemesexpert.com/products/wordpress-theme-bundle' );
	}
    if ( ! defined( 'PET_HOUSE_DEMO_IMPORT_URL' ) ) {
        define( 'PET_HOUSE_DEMO_IMPORT_URL', esc_url( admin_url( 'themes.php?page=pethouse-wizard' ) ) );
    }
}
endif;
add_action( 'after_setup_theme', 'pet_house_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $content_width
 */
function pet_house_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'pet_house_content_width', 1170 );
}
add_action( 'after_setup_theme', 'pet_house_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */

function pet_house_widgets_init() {
	
	register_sidebar( array(
		'name' => __( 'Sidebar Widget Area', 'pet-house' ),
		'id' => 'pet-house-sidebar-primary',
		'description' => __( 'The Primary Widget Area', 'pet-house' ),
		'before_widget' => '<aside id="%1$s" class="widget %2$s wow fadeInUp">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4><div class="title"><span class="shap"></span></div>',
	) );
	
	register_sidebar( array(
		'name' => __( 'Footer Widget Area', 'pet-house' ),
		'id' => 'pet-house-footer-widget-area',
		'description' => __( 'The Footer Widget Area', 'pet-house' ),
		'before_widget' => '<div class="footer-widget col-lg-3 col-sm-6 wow fadeIn" data-wow-delay="0.5s"><aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside></div>',
		'before_title' => '<h5 class="widget-title w-title">',
		'after_title' => '</h5><span class="shap"></span>',
	) );
}
add_action( 'widgets_init', 'pet_house_widgets_init' );

/**
 * All Styles & Scripts.
 */

require_once get_template_directory() . '/inc/enqueue.php';

/**
 * Nav Walker fo Bootstrap Dropdown Menu.
 */

require_once get_template_directory() . '/inc/class-wp-bootstrap-navwalker.php';

/**
 * Custom template tags for this theme.
 */
require_once get_template_directory() . '/inc/template-tags.php';

/**
 * Custom functions that act independently of the theme templates.
 */
require_once get_template_directory() . '/inc/extras.php';

/**
 * Customizer additions.
 */
require_once get_template_directory() . '/inc/customizer.php';

require_once get_template_directory() . '/inc/fonts.php';

require_once get_template_directory() . '/wptt-webfont-loader.php';


function pet_house_custom_controls() {
	load_template( trailingslashit( get_template_directory() ) . '/inc/customizer/customizer-custom-controls.php' );
}
add_action( 'customize_register', 'pet_house_custom_controls' );


add_filter( 'nav_menu_link_attributes', 'pet_house_dropdown_data_attribute', 20, 3 );
/**
 * Use namespaced data attribute for Bootstrap's dropdown toggles.
 *
 * @param array    $atts HTML attributes applied to the item's `<a>` element.
 * @param WP_Post  $item The current menu item.
 * @param stdClass $args An object of wp_nav_menu() arguments.
 * @return array
 */
function pet_house_dropdown_data_attribute( $atts, $item, $args ) {
    if ( is_a( $args->walker, 'WP_Bootstrap_Navwalker' ) ) {
        if ( array_key_exists( 'data-toggle', $atts ) ) {
            unset( $atts['data-toggle'] );
            $atts['data-bs-toggle'] = 'dropdown';
        }
    }
    return $atts;
}

function pet_house_remove_theme_customizer_setting($wp_customize) {
    // Remove the setting
    $wp_customize->remove_setting('display_header_text');
    // Remove the control
    $wp_customize->remove_control('display_header_text');
}
add_action('customize_register', 'pet_house_remove_theme_customizer_setting', 20); 
// Use a priority greater than the one used for adding the setting


// Set the number of products per row to 3 on the shop page
add_filter('loop_shop_columns', 'pet_house_custom_shop_loop_columns');

if (!function_exists('pet_house_custom_shop_loop_columns')) {
    function pet_house_custom_shop_loop_columns() {
        // Retrieve the number of columns from theme customizer setting (default: 3)
        $pet_house_columns = get_theme_mod('pet_house_custom_shop_per_columns', 3);
        return $pet_house_columns;
    }
}

// Set the number of products per page on the shop page
add_filter('loop_shop_per_page', 'pet_house_custom_shop_per_page', 20);

if (!function_exists('pet_house_custom_shop_per_page')) {
    function pet_house_custom_shop_per_page($pet_house_products_per_page) {
        // Retrieve the number of products per page from theme customizer setting (default: 9)
        $pet_house_products_per_page = get_theme_mod('pet_house_custom_shop_product_per_page', 9);
        return $pet_house_products_per_page;
    }
}

/**
 * Generate Google fonts URL.
 */
function pet_house_google_font_url() {
    $pet_house_font_family = array(
        'Inter:ital,wght@0,100..900;1,100..900'
    );

    $pet_house_query_args = array(
        'family' => implode('|', $pet_house_font_family), // No need for rawurlencode in this case
        'display' => 'swap' // Add display=swap to improve loading performance
    );

    return esc_url(add_query_arg($pet_house_query_args, 'https://fonts.googleapis.com/css2')); // Use https://fonts.googleapis.com/css2 for variable fonts
}


/**
 * Enqueue theme styles and scripts.
 */
function pet_house_scripts_styles() {
    // Enqueue Google Fonts
    wp_enqueue_style('pet-house-google-fonts', pet_house_google_font_url(), array(), null);
    
    // Enqueue other styles and scripts as needed
    wp_enqueue_style('pet-house-main-style', get_stylesheet_uri(), array(), '1.0.0');
    // Add more enqueuing here if needed
}
add_action('wp_enqueue_scripts', 'pet_house_scripts_styles');

function pet_house_fonts_scripts() {
	$pet_house_headings_font = esc_html(get_theme_mod('pet_house_headings_text'));
	$pet_house_body_font = esc_html(get_theme_mod('pet_house_body_text'));

	if( $pet_house_headings_font ) {
		wp_enqueue_style( 'pet-house-headings-fonts', '//fonts.googleapis.com/css?family='. $pet_house_headings_font );
	} else {
		wp_enqueue_style( 'pet-house-source-sans', '//fonts.googleapis.com/css?family=Lato:400,700,400italic,700italic');
	}
	if( $pet_house_body_font ) {
		wp_enqueue_style( 'pet-house-body-fonts', '//fonts.googleapis.com/css?family='. $pet_house_body_font );
	} else {
		wp_enqueue_style( 'pet-house-source-body', '//fonts.googleapis.com/css?family=Source+Sans+Pro:400,300,400italic,700,600');
	}
}
add_action( 'wp_enqueue_scripts', 'pet_house_fonts_scripts' );

function pet_house_customize_css() {
    $pet_house_dynamic_color = get_theme_mod( 'pet_house_dynamic_color_one', '#947147' );
    $pet_house_custom_css = ":root { --color-primary1: {$pet_house_dynamic_color}; }";
    wp_add_inline_style( 'pet-house-style', $pet_house_custom_css );
}
add_action( 'wp_enqueue_scripts', 'pet_house_customize_css' );

/**
 * Enqueue theme copyright alignment style.
 */
function pet_house_copyright_alignment_option() {
    // Get the alignment setting from the theme customizer.
    $pet_house_copyright_alignment = get_theme_mod('pet_house_copyright_alignment', 'center');

    // Start building the CSS string for the alignment.
    $pet_house_copyright_alignment_css = '
        .copyright-text, .footer-copyright, .footer-copyright a, p.copyright-text {
            text-align: ' . esc_attr($pet_house_copyright_alignment) . ';
        }
    ';

    // Add the inline style to the theme's main stylesheet.
    wp_add_inline_style('pet-house-style', $pet_house_copyright_alignment_css);
}

add_action('wp_enqueue_scripts', 'pet_house_copyright_alignment_option');

// Sanitize the input
function pet_house_sanitize_sidebar_position( $pet_house_input ) {
    $pet_house_valid = array( 'right', 'left' );

    if ( in_array( $pet_house_input, $pet_house_valid ) ) {
        return $pet_house_input;
    } else {
        return 'right';
    }
}

// Helper function to get page ID by slug
function get_page_id_by_slug($pet_house_slug) {
    $pet_house_page = get_page_by_path($pet_house_slug); // Get the page by slug
    return $pet_house_page ? $pet_house_page->ID : 0;   // Return the page ID or 0 if not found
}

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );

// Show Admin Notice
function pet_house_promo_notice() {
    if (get_option('pet_house_notice_dismissed')) {
        return;
    }

    if (isset($_GET['page']) && in_array($_GET['page'], ['pethouse-wizard'])) {
        return;
    }
    

    $pet_house_theme = wp_get_theme();
    $pet_house_theme_title = $pet_house_theme->get( 'Name' );
    $pet_house_theme_version = $pet_house_theme->get( 'Version' );

    ?>
    <div class="notice pet-house-notice is-dismissible">
        <div>
            <h3>
                <span><?php echo esc_html( '(Version: ' . $pet_house_theme_version . ')' ); ?></span><br>
                <?php esc_html_e( 'Thank you for choosing,', 'pet-house'); ?>
                <?php echo esc_html( $pet_house_theme_title ); ?> <?php esc_html_e( '!!!', 'pet-house'); ?>
            </h3>
            <p><?php esc_html_e( 'Welcome! You can now easily start building your website using our beautiful and user-friendly themes. No need to worry about setup — with our one-click demo importer, your site can look just like the demo in minutes. All the tools and information you need to get started are right here!', 'pet-house'); ?></p>
            <a class="button button-primary pet-house-buy-now" href="<?php echo esc_url( PET_HOUSE_DEMO_IMPORT_URL ); ?>" target="_blank">
                <?php esc_html_e( 'One Click Demo Import', 'pet-house') ?>
            </a>
            <a class="button button-primary pet-house-bundle-button" target="_blank" href="<?php echo esc_url( PET_HOUSE_THEME_BUNDLE_URL ); ?>">
                <?php echo esc_html__( 'Get All 60+ Themes @ $79', 'pet-house' ); ?>
            </a>
        </div>
        <div class="pet-house-image-wrap">
            <img src="<?php echo esc_url(get_stylesheet_directory_uri() . '/screenshot.png'); ?>">
        </div>
        <canvas id="pet-house-notice-confetti"></canvas>
    </div>
    <?php
}
add_action('admin_notices', 'pet_house_promo_notice');

add_action('wp_ajax_pet_house_dismiss_notice', 'pet_house_dismiss_notice');
function pet_house_dismiss_notice() {
    update_option('pet_house_notice_dismissed', true);
    wp_send_json_success();
}

add_action('after_switch_theme', 'pet_house_reset_notice_on_activation');
function pet_house_reset_notice_on_activation() {
    delete_option('pet_house_notice_dismissed');
}

function pet_house_enqueue_admin_assets() {
    wp_enqueue_script(
        'pet-house-confetti',
        get_template_directory_uri() . '/demo-import/assets/js/confetti/confetti.min.js',
        ['jquery'],
        null,
        true
    );

    wp_enqueue_script(
        'pet-house-notice-confetti-js',
        get_template_directory_uri() . '/demo-import/assets/js/plugin-update-notice.js',
        ['pet-house-confetti'],
        null,
        true
    );

    wp_enqueue_script(
        'pet-house-notice-dismiss',
        get_template_directory_uri() . '/demo-import/assets/js/notice-dismiss.js',
        ['jquery'],
        null,
        true
    );
}
add_action('admin_enqueue_scripts', 'pet_house_enqueue_admin_assets');